From 9ad00dd879ae1fe0a1a9a46aeeb7be981bf7ee8c Mon Sep 17 00:00:00 2001
From: John <johnz@posteo.net>
Date: Thu, 23 May 2019 08:49:40 +0200
Subject: [PATCH 1/7] qt5: update to 5.13.0

qt5: update ppc64(le) support + add big endian
---
 common/shlibs                                 |    3 +
 srcpkgs/{qt5-canvas3d => qt5-lottie}          |    0
 srcpkgs/qt5-lottie-devel                      |    1 +
 .../0090-hard-disable-qmlchachegen.patch      |   10 +
 srcpkgs/qt5/files/assistant.pro               |    2 -
 srcpkgs/qt5/files/lrelease.pro                |   10 +-
 srcpkgs/qt5/files/lupdate.pro                 |    8 +-
 srcpkgs/qt5/files/moc/moc.pro                 |    8 -
 .../qt5/files/qdbuscpp2xml/qdbuscpp2xml.pro   |    8 -
 srcpkgs/qt5/files/qlalr/qlalr.pro             |   23 -
 srcpkgs/qt5/files/qmlimportscanner.pro        |    2 +-
 srcpkgs/qt5/files/qmllint.pro                 |    4 +-
 srcpkgs/qt5/files/qmlmin.pro                  |    2 +-
 srcpkgs/qt5/files/qttools_src.pro             |    1 -
 srcpkgs/qt5/files/rcc.pro                     |    2 +
 srcpkgs/qt5/files/rcc/rcc.pro                 |    6 -
 srcpkgs/qt5/files/uic.pro                     |    1 +
 srcpkgs/qt5/files/uic/uic.pro                 |   11 -
 ...t-between-musl-libc-dirent.h-and-lss.patch |   35 -
 .../patches/0004-musl-dispatch-to-musl.patch  |   26 +-
 ...-is-a-nonportable-alias-for-signal.h.patch |   81 -
 .../qt5/patches/0008-musl-no-mallinfo.patch   |   11 -
 srcpkgs/qt5/patches/0013-musl-serialio.patch  |   12 -
 .../qt5/patches/0017-musl-stackstart.patch    |    4 +-
 .../qt5/patches/0021-chromium-mojo-gcc8.patch |   18 -
 .../qt5/patches/0022-libressl-compat.patch    |   27 +-
 .../qt5/patches/0023-enable_tools-cross.patch |   35 +-
 srcpkgs/qt5/patches/0027-skia_cpu-be.patch    |   12 -
 srcpkgs/qt5/patches/0028-webrtc-be.patch      |   12 -
 srcpkgs/qt5/patches/0029-musl-libevent.patch  |  121 -
 ..._remove_our_use_of_syscall_for-statx.patch |  119 -
 srcpkgs/qt5/patches/0034-gcc-8.3-build.patch  |  236 -
 srcpkgs/qt5/patches/0035-gcc-9.1-build.patch  |   35 -
 srcpkgs/qt5/patches/0040-yasm-nls.patch       |   13 +
 srcpkgs/qt5/patches/0041-libressl.patch       |   11 +
 .../0042-arm-void-is-not-android.patch        |   21 +
 ...io.patch => 0043-libressl-const-bio.patch} |    8 +-
 ...info.patch => 0044-qt-musl-execinfo.patch} |   85 +-
 .../0045-qt-musl-thread-stacksize.patch       |   26 +
 .../qt5/patches/0046-sandbox-membarrier.patch |   60 +
 .../qt5/patches/0047-gn-cross-sysroot.patch   |   24 +
 .../qt5/patches/0089-webengine-ppc64.patch    |   20 +
 .../qt5/patches/0090-chromium-ppc64le.patch   | 4267 +++++++++++++++++
 .../patches/0091-chromium-ppc64-musl.patch    |  141 +
 .../qt5/patches/0092-chromium-ppc64-be.patch  | 2970 ++++++++++++
 .../qt5/patches/0093-chromium-v8-elfv2.patch  |   43 +
 .../0094-big-endian-skia-portable.patch       |   17 +
 .../patches/qtwebengine-chromium-ppc64.patch  | 2112 --------
 .../patches/qtwebengine-enable-ppc64.patch    |   41 -
 srcpkgs/qt5/template                          |  137 +-
 50 files changed, 7805 insertions(+), 3077 deletions(-)
 rename srcpkgs/{qt5-canvas3d => qt5-lottie} (100%)
 create mode 120000 srcpkgs/qt5-lottie-devel
 create mode 100644 srcpkgs/qt5/files/0090-hard-disable-qmlchachegen.patch
 delete mode 100644 srcpkgs/qt5/files/moc/moc.pro
 delete mode 100644 srcpkgs/qt5/files/qdbuscpp2xml/qdbuscpp2xml.pro
 delete mode 100644 srcpkgs/qt5/files/qlalr/qlalr.pro
 delete mode 100644 srcpkgs/qt5/files/rcc/rcc.pro
 delete mode 100644 srcpkgs/qt5/files/uic/uic.pro
 delete mode 100644 srcpkgs/qt5/patches/0001-Fix-conflict-between-musl-libc-dirent.h-and-lss.patch
 delete mode 100644 srcpkgs/qt5/patches/0006-sys-signal.h-is-a-nonportable-alias-for-signal.h.patch
 delete mode 100644 srcpkgs/qt5/patches/0013-musl-serialio.patch
 delete mode 100644 srcpkgs/qt5/patches/0021-chromium-mojo-gcc8.patch
 delete mode 100644 srcpkgs/qt5/patches/0027-skia_cpu-be.patch
 delete mode 100644 srcpkgs/qt5/patches/0028-webrtc-be.patch
 delete mode 100644 srcpkgs/qt5/patches/0029-musl-libevent.patch
 delete mode 100644 srcpkgs/qt5/patches/0033-revert_remove_our_use_of_syscall_for-statx.patch
 delete mode 100644 srcpkgs/qt5/patches/0034-gcc-8.3-build.patch
 delete mode 100644 srcpkgs/qt5/patches/0035-gcc-9.1-build.patch
 create mode 100644 srcpkgs/qt5/patches/0040-yasm-nls.patch
 create mode 100644 srcpkgs/qt5/patches/0041-libressl.patch
 create mode 100644 srcpkgs/qt5/patches/0042-arm-void-is-not-android.patch
 rename srcpkgs/qt5/patches/{libressl-const-bio.patch => 0043-libressl-const-bio.patch} (84%)
 rename srcpkgs/qt5/patches/{0005-musl-no-execinfo.patch => 0044-qt-musl-execinfo.patch} (56%)
 create mode 100644 srcpkgs/qt5/patches/0045-qt-musl-thread-stacksize.patch
 create mode 100644 srcpkgs/qt5/patches/0046-sandbox-membarrier.patch
 create mode 100644 srcpkgs/qt5/patches/0047-gn-cross-sysroot.patch
 create mode 100644 srcpkgs/qt5/patches/0089-webengine-ppc64.patch
 create mode 100644 srcpkgs/qt5/patches/0090-chromium-ppc64le.patch
 create mode 100644 srcpkgs/qt5/patches/0091-chromium-ppc64-musl.patch
 create mode 100644 srcpkgs/qt5/patches/0092-chromium-ppc64-be.patch
 create mode 100644 srcpkgs/qt5/patches/0093-chromium-v8-elfv2.patch
 create mode 100644 srcpkgs/qt5/patches/0094-big-endian-skia-portable.patch
 delete mode 100644 srcpkgs/qt5/patches/qtwebengine-chromium-ppc64.patch
 delete mode 100644 srcpkgs/qt5/patches/qtwebengine-enable-ppc64.patch

diff --git a/common/shlibs b/common/shlibs
index 0f6742b2fa4..96ee3526e57 100644
--- a/common/shlibs
+++ b/common/shlibs
@@ -1850,10 +1850,13 @@ libQt5Quick.so.5 qt5-declarative-5.6.0_1
 libQt5QuickTest.so.5 qt5-declarative-5.6.0_1
 libQt5QuickWidgets.so.5 qt5-declarative-5.6.0_1
 libQt5QuickParticles.so.5 qt5-declarative-5.6.0_1
+libQt5QuickShapes.so.5 qt5-declarative-5.12.1_1
 libQt5QuickControls2.so.5 qt5-quickcontrols2-5.7.1_1
 libQt5QuickTemplates2.so.5 qt5-quickcontrols2-5.7.1_1
 libQt5Positioning.so.5 qt5-location-5.6.0_1
 libQt5Location.so.5 qt5-location-5.6.0_1
+libQt5PositioningQuick.so.5 qt5-location-5.12.1_1
+libQt5VirtualKeyboard.so.5 qt5-virtualkeyboard-5.12.1_1
 libQt5Multimedia.so.5 qt5-multimedia-5.6.0_1
 libQt5MultimediaGstTools.so.5 qt5-multimedia-5.10.1_1
 libQt5MultimediaQuick.so.5 qt5-multimedia-5.10.1_1
diff --git a/srcpkgs/qt5-lottie-devel b/srcpkgs/qt5-lottie-devel
new file mode 120000
index 00000000000..75793eb6664
--- /dev/null
+++ b/srcpkgs/qt5-lottie-devel
@@ -0,0 +1 @@
+qt5
\ No newline at end of file
diff --git a/srcpkgs/qt5/files/assistant.pro b/srcpkgs/qt5/files/assistant.pro
index 3e32776a827..5100f61105e 100644
--- a/srcpkgs/qt5/files/assistant.pro
+++ b/srcpkgs/qt5/files/assistant.pro
@@ -5,9 +5,7 @@ SUBDIRS += \
            assistant \
            qhelpgenerator \
            qcollectiongenerator \
-           qhelpconverter
 
 assistant.depends = help
-qhelpgenerator.depends = help
 qcollectiongenerator.depends = help
 qhelpconverter.depends = help
diff --git a/srcpkgs/qt5/files/lrelease.pro b/srcpkgs/qt5/files/lrelease.pro
index 4dbd4ce5327..bab6b2928e4 100644
--- a/srcpkgs/qt5/files/lrelease.pro
+++ b/srcpkgs/qt5/files/lrelease.pro
@@ -1,10 +1,16 @@
 QT = core qml network core-private
 DEFINES += QT_NO_CAST_FROM_ASCII QT_NO_CAST_TO_ASCII
 
-SOURCES += main.cpp
+HEADERS += \
+    ../shared/projectdescriptionreader.h \
+    ../shared/runqttool.h
+
+SOURCES += \
+    ../shared/projectdescriptionreader.cpp \
+    ../shared/runqttool.cpp \
+    main.cpp
 
 include(../shared/formats.pri)
-include(../shared/proparser.pri)
 
 qmake.name = QMAKE
 qmake.value = $$shell_path($$QMAKE_QMAKE)
diff --git a/srcpkgs/qt5/files/lupdate.pro b/srcpkgs/qt5/files/lupdate.pro
index c867ace9099..bf687113c86 100644
--- a/srcpkgs/qt5/files/lupdate.pro
+++ b/srcpkgs/qt5/files/lupdate.pro
@@ -3,13 +3,14 @@ QT = core qml network core-private qmldevtools-private
 DEFINES += QT_NO_CAST_TO_ASCII QT_NO_CAST_FROM_ASCII
 
 include(../shared/formats.pri)
-include(../shared/proparser.pri)
 
-DEFINES += PROEVALUATOR_DEBUG
 
 SOURCES += \
     main.cpp \
     merge.cpp \
+    ../shared/projectdescriptionreader.cpp \
+    ../shared/runqttool.cpp \
+    ../shared/qrcreader.cpp \
     ../shared/simtexth.cpp \
     \
     cpp.cpp \
@@ -20,6 +21,9 @@ SOURCES += qdeclarative.cpp
 
 HEADERS += \
     lupdate.h \
+    ../shared/projectdescriptionreader.h \
+    ../shared/qrcreader.h \
+    ../shared/runqttool.h \
     ../shared/simtexth.h
 
 mingw {
diff --git a/srcpkgs/qt5/files/qmlimportscanner.pro b/srcpkgs/qt5/files/qmlimportscanner.pro
index f92234ad442..57c228b8540 100644
--- a/srcpkgs/qt5/files/qmlimportscanner.pro
+++ b/srcpkgs/qt5/files/qmlimportscanner.pro
@@ -1,7 +1,7 @@
 QT = core qml network qmldevtools-private
 DEFINES += QT_NO_CAST_TO_ASCII QT_NO_CAST_FROM_ASCII
 
-SOURCES += main.cpp ../../src/qml/parser/qqmljsgrammar.cpp
+SOURCES += main.cpp ../../src/qml/qqmljsgrammar.cpp
 
 QMAKE_TARGET_DESCRIPTION = QML Import Scanner
 
diff --git a/srcpkgs/qt5/files/qmllint.pro b/srcpkgs/qt5/files/qmllint.pro
index 032d02cf33b..409a378bfcb 100644
--- a/srcpkgs/qt5/files/qmllint.pro
+++ b/srcpkgs/qt5/files/qmllint.pro
@@ -1,6 +1,6 @@
-QT = core qml network qmldevtools-private
+QT = core qml qmldevtools-private
 
-SOURCES += main.cpp ../../src/qml/parser/qqmljsgrammar.cpp
+SOURCES += main.cpp ../../src/qml/qqmljsgrammar.cpp
 
 QMAKE_TARGET_DESCRIPTION = QML Syntax Verifier
 
diff --git a/srcpkgs/qt5/files/qmlmin.pro b/srcpkgs/qt5/files/qmlmin.pro
index 58f75c76e01..f096b414bf4 100644
--- a/srcpkgs/qt5/files/qmlmin.pro
+++ b/srcpkgs/qt5/files/qmlmin.pro
@@ -1,5 +1,5 @@
 QT       = core qml network qmldevtools-private
-SOURCES += main.cpp ../../src/qml/parser/qqmljsgrammar.cpp
+SOURCES += main.cpp ../../src/qml/qqmljsgrammar.cpp
 
 QMAKE_TARGET_DESCRIPTION = QML/JS Minifier
 
diff --git a/srcpkgs/qt5/files/qttools_src.pro b/srcpkgs/qt5/files/qttools_src.pro
index 7b39f929e77..c7344404c05 100644
--- a/srcpkgs/qt5/files/qttools_src.pro
+++ b/srcpkgs/qt5/files/qttools_src.pro
@@ -5,7 +5,6 @@ SUBDIRS = assistant \
 	designer \
 	linguist \
 	qdbus \
-	qdoc \
 	qtattributionsscanner
 
 linguist.depends = designer
diff --git a/srcpkgs/qt5/files/rcc.pro b/srcpkgs/qt5/files/rcc.pro
index 8046b72b48d..3296979769b 100644
--- a/srcpkgs/qt5/files/rcc.pro
+++ b/srcpkgs/qt5/files/rcc.pro
@@ -6,3 +6,5 @@ SOURCES += main.cpp
 
 QMAKE_TARGET_DESCRIPTION = "Qt Resource Compiler"
 load(qt_tool)
+
+DEFINES += QT_FEATURE_zstd=-1
diff --git a/srcpkgs/qt5/files/uic.pro b/srcpkgs/qt5/files/uic.pro
index 30f98644eb7..74d7dbd878f 100644
--- a/srcpkgs/qt5/files/uic.pro
+++ b/srcpkgs/qt5/files/uic.pro
@@ -2,6 +2,7 @@ QT = core qml core-private qmldevtools-private
 DEFINES += QT_UIC QT_NO_CAST_FROM_ASCII QT_NO_FOREACH
 
 include(uic.pri)
+include(shared/shared.pri)
 include(cpp/cpp.pri)
 
 HEADERS += uic.h
diff --git a/srcpkgs/qt5/template b/srcpkgs/qt5/template
index 8d170535e89..565d7f59544 100644
--- a/srcpkgs/qt5/template
+++ b/srcpkgs/qt5/template
@@ -1,7 +1,7 @@
 # Template file for 'qt5'
 pkgname=qt5
-version=5.11.3
-revision=8
+version=5.13.0
+revision=1
 wrksrc="qt-everywhere-src-${version}"
 build_style=gnu-configure
 hostmakedepends="cmake clang flex git glib-devel gperf ninja pkg-config
@@ -10,32 +10,46 @@ makedepends="SDL2-devel Vulkan-Headers alsa-lib-devel double-conversion-devel
  eudev-libudev-devel ffmpeg-devel freetds-devel glib-devel gst-plugins-base1-devel
  gtk+3-devel icu-devel jsoncpp-devel libXv-devel libbluetooth-devel libcap-devel
  libevent-devel libinput-devel libmng-devel libmysqlclient-devel libproxy-devel
- libvpx5-devel libwebp-devel libxslt-devel minizip-devel nss-devel
+ libvpx-devel libwebp-devel libxslt-devel minizip-devel nss-devel cups-devel
  opus-devel pciutils-devel pcre2-devel postgresql-libs-devel
  protobuf-devel pulseaudio-devel snappy-devel tslib-devel
  unixodbc-devel xcb-util-image-devel xcb-util-keysyms-devel
- xcb-util-renderutil-devel xcb-util-wm-devel"
+ xcb-util-renderutil-devel xcb-util-wm-devel libzstd-devel"
 depends="qtchooser"
 short_desc="Cross-platform application and UI framework (QT5)"
 maintainer="Jürgen Buchmüller <pullmoll@t-online.de>"
-license="GPL-3.0-or-later, LGPL-2.1-or-later"
+license="GPL-3.0-or-later, LGPL-3.0-or-later"
 homepage="https://qt.io/"
 distfiles="http://download.qt.io/official_releases/qt/${version%.*}/${version}/single/qt-everywhere-src-${version}.tar.xz"
-checksum=859417642713cee2493ee3646a7fee782c9f1db39e41d7bb1322bba0c5f0ff4d
+checksum=2cba31e410e169bd5cdae159f839640e672532a4687ea0f265f686421e0e86d6
 replaces="qt5-doc<5.6.0 qt5-quick1<5.6.0 qt5-quick1-devel<5.6.0 qt5-webkit<5.6.0 qt5-webkit-devel<5.6.0
- qt5-enginio<5.7.1 qt5-enginio-devel<5.7.1 qt5-plugin-gtk<5.7.1"
+ qt5-enginio<5.7.1 qt5-enginio-devel<5.7.1 qt5-plugin-gtk<5.7.1 qt5-canvas3d<5.13.0"
 
 build_options="webengine"
 desc_option_webengine="Build Chromium-based WebEngine component"
 
 case "$XBPS_TARGET_MACHINE" in
-	x86_64*|i686*|ppc64le*) build_options_default="webengine";;
+	x86_64*|i686*|ppc64*) build_options_default="webengine";;
 	armv5tel*) ;; # qtwebengine uses VSM assembler commands
-	arm*|aarch64*) build_options_default="webengine";;
+	aarch64*) build_options_default="webengine";;
+	arm*) ;; # qtwebengine requires a 32bit host toolchain http://sprunge.us/rbRyWQ
 	*) ;; # assume no webengine
 esac
 
-subpackages="qt5-3d qt5-3d-devel qt5-canvas3d qt5-charts qt5-charts-devel
+if [ "$build_option_webengine" ]; then
+	# v8 requires libatomic on ppc*/s390x/mips*
+	case "$XBPS_TARGET_MACHINE" in
+		mips*|ppc*) makedepends+=" libatomic-devel" ;;
+		*) ;;
+	esac
+	# also need it on host when it's one of those archs
+	case "$XBPS_MACHINE" in
+		mips*|ppc*) hostmakedepends+=" libatomic-devel" ;;
+		*) ;;
+	esac
+fi
+
+subpackages="qt5-3d qt5-3d-devel qt5-charts qt5-charts-devel
  qt5-connectivity qt5-connectivity-devel qt5-datavis3d qt5-datavis3d-devel
  qt5-declarative qt5-declarative-devel qt5-devel qt5-examples qt5-gamepad
  qt5-gamepad-devel qt5-graphicaleffects qt5-host-tools qt5-imageformats
@@ -51,7 +65,8 @@ subpackages="qt5-3d qt5-3d-devel qt5-canvas3d qt5-charts qt5-charts-devel
  qt5-virtualkeyboard-devel qt5-wayland qt5-wayland-devel qt5-webchannel
  qt5-webchannel-devel qt5-webglplugin qt5-webglplugin-devel qt5-websockets
  qt5-websockets-devel qt5-webview qt5-webview-devel qt5-x11extras
- qt5-x11extras-devel qt5-xmlpatterns qt5-xmlpatterns-devel"
+ qt5-x11extras-devel qt5-xmlpatterns qt5-xmlpatterns-devel
+ qt5-lottie qt5-lottie-devel"
 
 if [ "$build_option_webengine" ]; then
 	subpackages+=" qt5-webengine qt5-webengine-devel"
@@ -60,6 +75,7 @@ fi
 if [ "${XBPS_MACHINE%%-musl}" = i686 ]; then
 	nodebug=yes  # prevent OOM
 fi
+
 # Work around SSLv3_{client,server}_method missing in libressl-2.3.3
 CFLAGS="-DOPENSSL_NO_PSK -DOPENSSL_NO_NEXTPROTONEG"
 CXXFLAGS="${CFLAGS} -Wno-deprecated-declarations -Wno-class-memaccess -Wno-packed-not-aligned"
@@ -70,6 +86,7 @@ if [ "$CROSS_BUILD" ]; then
 	# Need some devel packages in the host to build qmake, moc, uic, rcc
 	# wayland-devel contains /usr/bin/wayland-scanner
 	hostmakedepends+=" icu-devel wayland-devel zlib-devel"
+	hostmakedepends+=" postgresql-libs-devel"
 	# Cross building qtwebengine requires some more host packages
 	if [ "$build_option_webengine" ]; then
 		hostmakedepends+=" nss-devel libevent-devel"
@@ -78,48 +95,18 @@ fi
 
 _bootstrap_gn() {
 	# Bootstrap gn (generate ninja)
-	_msg_cross "Bootstrapping 'gn'"
-	cd ${wrksrc}/qtwebengine/src/3rdparty/chromium/tools/gn
-	conf='is_clang=false'
-	conf+=' treat_warnings_as_errors=false'
-	conf+=' enable_remoting=false'
-	conf+=' enable_nacl=false'
-	conf+=' use_cups=false'
-	conf+=' use_gconf=false'
-	conf+=' use_gio=false'
-	conf+=' use_gnome_keyring=false'
-	conf+=' use_gtk=false'
-	conf+=' use_kerberos=false'
-	conf+=' linux_use_bundled_binutils=false'
-	conf+=' binutils_path="/usr/bin"'
-	conf+=' use_gold=false'
-	conf+=' use_sysroot=false'
-	conf+=' use_allocator="none"'
-	conf+=' is_android=false'
-
-	sed -i ${wrksrc}/qtwebengine/src/core/config/linux.pri \
-		-e "/equals(MARMV/s;true;false;"
-	case "$XBPS_TARGET_MACHINE" in
-		armv[56]*) conf+=' arm_use_neon=false arm_optionally_use_neon=false';;
-		armv7*)    conf+=' arm_use_neon=true arm_optionally_use_neon=false';;
-		aarch64*)  conf+=' arm_use_neon=true arm_optionally_use_neon=false';;
-	esac
-
-	AR="$AR_host" CC="$CC_host" CXX="$CXX_host" LD="$CXX_host" \
+	echo "Bootstrapping 'gn'"
+	cd ${wrksrc}/qtwebengine/src/3rdparty/gn
 	CFLAGS="$CFLAGS_host" CXXFLAGS="$CXXFLAGS_host" LDFLAGS="$LDFLAGS_host" \
 	PKGCONFIG=/usr/bin/pkgconfig PKG_CONFIG_PATH="/usr/lib/pkgconfig:/usr/share/pkgconfig" \
-		python2 bootstrap/bootstrap.py -n --gn-gen-args "${conf}"
+		python2 build/gen.py --no-last-commit-position --out-path \
+			${wrksrc}/qtwebengine/src/3rdparty/gn/out/Release --cc "$CC_host" \
+			--cxx "$CXX_host" --ld "$CXX_host" --ar "$AR_host"
+	ninja -C out/Release gn
 	cd ${wrksrc}
-
-	mkdir -p ${wrksrc}/qtwebengine/src/3rdparty/chromium/tools/gn/out/Release
-	cp -p ${wrksrc}/qtwebengine/src/3rdparty/chromium/out/Release/gn \
-		${wrksrc}/qtwebengine/src/3rdparty/chromium/tools/gn/out/Release/
-
-	# Remove gn from SUBDIRS for qtwebengine/src/buildtools
-	sed -i ${wrksrc}/qtwebengine/src/buildtools/buildtools.pro \
-		-e"/gn.file = gn.pro/,+3d"
 }
 
+
 _cleanup_wrksrc_leak() {
 	if [ -d "${PKGDESTDIR}/usr/lib/cmake" ]; then
 		# Replace references to ${wrksrc} in cmake files
@@ -137,7 +124,10 @@ _cleanup_wrksrc_leak() {
 	# and replace references to ${wrksrc}
 	find ${PKGDESTDIR} -iname "*.prl" -exec sed -i "{}" \
 		-e "/^QMAKE_PRL_BUILD_DIR/d" \
-		-e "s;-L${wrksrc}/qtbase/lib;-L/usr/lib;g" \;
+		-e "s;-L${wrksrc}/qtbase/lib;-L/usr/lib;g" \
+		-e "s%/usr/lib/lib\([^[:space:]]*\)\.[sa][o]*%-l\1%g" \;
+	find ${PKGDESTDIR} -iname "*.pri" -exec sed -i "{}" \
+		-e "s%/usr/lib/lib\([^[:space:]]*\)\.[sa][o]*%-l\1%g" \;
 	# Replace ${wrksrc} in project include files
 	find ${PKGDESTDIR} -iname "*.pri" -exec sed -i "{}" \
 		-e "s;${wrksrc}/qtbase;/usr/lib/qt5;g" \;
@@ -253,9 +243,6 @@ do_configure() {
 			qtwebengine/src/3rdparty/chromium/third_party/pdfium/third_party/base/allocator/partition_allocator/spin_lock.cc \
 			-e 's;"yield";"nop";'
 		;;
-	ppc64le*) # enable webengine but not on BE ppc64 for now
-		sed -i qtwebengine/mkspecs/features/platform.prf -e 's;#ppc64le;;'
-		;;
 	esac
 
 	case "$XBPS_TARGET_MACHINE" in
@@ -285,8 +272,7 @@ do_configure() {
 		for d in $(ls ${wrksrc}/qtbase/include); do
 			ln -sfv ${version}/${d}/private qtbase/include/${d}/private
 		done
-
-		if [ "$build_option_webengine" ]; then
+if [ "$build_option_webengine" ]; then
 			_bootstrap_gn
 		fi
 
@@ -307,6 +293,7 @@ do_configure() {
 				-e '/#error Read the comment at this location/d'
 			;;
 		esac
+		patch -Np0 < ${FILESDIR}/0090-hard-disable-qmlchachegen.patch
 	else
 		# qmake {CXX,L}FLAGS patches
 		sed -i -e "s|^\(CXXFLAGS =.*\)|\1 ${CXXFLAGS}|" \
@@ -339,6 +326,10 @@ do_configure() {
 	opts+=" -icu"
 	opts+=" -openssl-linked"
 	opts+=" -dbus-linked"
+	opts+=" -sql-mysql"
+	opts+=" -mysql_config ${XBPS_CROSS_BASE}/usr/bin/mysql_config"
+	opts+=" -sql-psql"
+	opts+=" -psql_config /usr/bin/pg_config"
 	opts+=" -no-pch"
 	opts+=" -no-strip"
 	opts+=" -nomake examples"
@@ -369,12 +360,10 @@ do_configure() {
 	fi
 	opts+=" -silent"
 	# opts+=" -v"
-
 	# make sure to disable webengine on platforms that we don't build it for
 	if [ -z "$build_option_webengine" ]; then
 		opts+=" -skip qtwebengine"
 	fi
-
 	LDFLAGS+=" -Wl,--no-keep-memory"  # needs more than 8GB RAM else
 	if [ "$CROSS_BUILD" ]; then
 		spec=void-${XBPS_CROSS_TRIPLET}-g++
@@ -392,6 +381,19 @@ do_configure() {
 			fi
 			;;
 		esac
+		case "$XBPS_TARGET_MACHINE" in
+		aarch64*|armv7*)
+			sed -i ${wrksrc}/qtwebengine/src/core/config/linux.pri \
+				-e "/arm_use_neon=/s;false;true;"
+			;;
+		arm*)
+			sed -i ${wrksrc}/qtwebengine/src/core/config/linux.pri \
+				-e "/arm_use_neon=/s;true;false;"
+
+			;;
+		esac
+		sed -i ${wrksrc}/qtwebengine/src/core/config/linux.pri \
+			-e "/equals(MARMV/s;true;false;"
 
 		# Make sure libQt5Designer is built
 		cp -v ${FILESDIR}/qttools_src.pro qttools/src/src.pro
@@ -425,7 +427,6 @@ do_install() {
 	cd ${wrksrc}/qtbase
 	make INSTALL_ROOT=${DESTDIR} install
 
-	vlicense ${wrksrc}/LGPL_EXCEPTION.txt
 	_cleanup_wrksrc_leak
 
 	# Symbolic links for remaining binaries
@@ -547,6 +548,7 @@ do_install() {
 			[ -f "${base}.pro.orig" ] && mv -v ${base}.pro{.orig,}
 			[ -f Makefile.orig ] && mv -v Makefile{.orig,}
 			# Avoid rebuilding the Makefile by changing the rule
+			sed -i Makefile -e 's;^all:.*;all:;'
 			sed -i Makefile -e "s;^Makefile:;Makefile.host:;"
 			if [ -x "${wrksrc}/${dir}/bin/${base}-host" ]; then
 				mv -v ${wrksrc}/${dir}/bin/${base}{-host,}
@@ -574,13 +576,6 @@ qt5-3d_package() {
 	}
 }
 
-qt5-canvas3d_package() {
-	short_desc+=" - Canvas 3D component"
-	pkg_install() {
-		_install_subpkg qtcanvas3d
-	}
-}
-
 qt5-charts-devel_package() {
 	short_desc+=" - Charts component (development)"
 	depends="qt5-charts-${version}_${revision} qt5-declarative-devel-${version}_${revision}"
@@ -662,6 +657,18 @@ qt5-examples_package() {
 	}
 }
 
+qt5-lottie-devel_package() {
+	pkg_install() {
+		_install_devel qtlottie
+	}
+}
+
+qt5-lottie_package() {
+	pkg_install() {
+		_install_subpkg qtlottie
+	}
+}
+
 qt5-gamepad-devel_package() {
 	short_desc+=" - Gamepad component (development)"
 	depends="qt5-gamepad-${version}_${revision} qt5-declarative-devel-${version}_${revision}"
@@ -1115,7 +1122,7 @@ qt5-tools_package() {
 qt5-devel_package() {
 	depends="zlib-devel libressl-devel>=2.1.4 libXext-devel libXrender-devel
 		fontconfig-devel libglib-devel MesaLib-devel mtdev-devel
-		dbus-devel icu-devel qt5-${version}_${revision}
+		dbus-devel icu-devel cups-devel qt5-${version}_${revision}
 		qt5-qmake-${version}_${revision}
 		qt5-host-tools-${version}_${revision}"
 	short_desc+=" - Development files"

